dma: add optional slow linked list walking
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1
28 return 0
29}
30
31check_define_val()
32{
33 $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}'
34 return 0
35}
36
37# setting options to "yes" or "no" will make that choice default,
38# "" means "autodetect".
39
40platform_list="generic pandora maemo caanoo libretro"
41platform="generic"
42builtin_gpu_list="peops unai neon senquack"
43builtin_gpu=""
44sound_driver_list="oss alsa pulseaudio sdl libretro"
45sound_drivers=""
46plugins="plugins/spunull/spunull.so \
47plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so plugins/gpu_senquack/gpu_senquack.so"
48drc_cache_base="no"
49have_armv5=""
50have_armv6=""
51have_armv7=""
52have_arm_neon=""
53have_arm_neon_asm=""
54have_tslib=""
55have_gles=""
56have_c64x_dsp=""
57enable_dynarec="yes"
58need_sdl="no"
59need_xlib="no"
60need_libpicofe="yes"
61need_warm="no"
62CFLAGS_GLES=""
63LDLIBS_GLES=""
64# these are for known platforms
65optimize_cortexa8="no"
66optimize_arm926ej="no"
67
68# hardcoded stuff
69CC="${CC-${CROSS_COMPILE}gcc}"
70CXX="${CXX-${CROSS_COMPILE}g++}"
71AS="${AS-${CROSS_COMPILE}as}"
72AR="${AS-${CROSS_COMPILE}ar}"
73MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread"
74config_mak="config.mak"
75
76SYSROOT="$(${CC} --print-sysroot)"
77[ "x${SDL_CONFIG}" = "x" ] && SDL_CONFIG="${SYSROOT}/usr/bin/sdl-config"
78
79fail()
80{
81 echo "$@"
82 if test -n "$DUMP_CONFIG_LOG"; then cat config.log; fi
83 exit 1
84}
85
86# call during arg parsing, so that cmd line can override platform defaults
87set_platform()
88{
89 platform=$1
90 case "$platform" in
91 generic)
92 ;;
93 pandora)
94 sound_drivers="oss alsa"
95 drc_cache_base="yes"
96 optimize_cortexa8="yes"
97 have_arm_neon="yes"
98 need_xlib="yes"
99 ;;
100 maemo)
101 drc_cache_base="yes"
102 optimize_cortexa8="yes"
103 have_arm_neon="yes"
104 ;;
105 caanoo)
106 sound_drivers="oss"
107 drc_cache_base="yes"
108 optimize_arm926ej="yes"
109 need_warm="yes"
110 ;;
111 libretro)
112 sound_drivers="libretro"
113 need_libpicofe="no"
114 ;;
115 *)
116 fail "unsupported platform: $platform"
117 ;;
118 esac
119}
120
121for opt do
122 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
123 case "$opt" in
124 --help|-h) show_help="yes"
125 ;;
126 --platform=*) set_platform "$optarg"
127 ;;
128 --gpu=*) builtin_gpu="$optarg"
129 ;;
130 --sound-drivers=*) sound_drivers="$optarg"
131 ;;
132 --enable-neon) have_arm_neon="yes"
133 ;;
134 --disable-neon) have_arm_neon="no"
135 ;;
136 --disable-dynarec) enable_dynarec="no"
137 ;;
138 *) echo "ERROR: unknown option $opt"; show_help="yes"
139 ;;
140 esac
141done
142
143if [ "$show_help" = "yes" ]; then
144 echo "options:"
145 echo " --help print this message"
146 echo " --platform=NAME target platform [$platform]"
147 echo " available: $platform_list"
148 echo " --gpu=NAME builtin gpu plugin [guessed]"
149 echo " available: $builtin_gpu_list"
150 echo " --sound-drivers=LIST sound output drivers [guessed]"
151 echo " available: $sound_driver_list"
152 echo " --enable-neon"
153 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
154 echo " --disable-dynarec disable dynamic recompiler"
155 echo " (dynarec is only available and enabled on ARM)"
156 echo " --disable-icache-emu Disables the instruction cache emulation"
157 echo "influential environment variables:"
158 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
159 exit 1
160fi
161
162# validate selections
163if [ "x$builtin_gpu" != "x" ]; then
164 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
165 fail "unsupported builtin gpu plugin: $builtin_gpu"
166 fi
167fi
168
169if [ "x$sound_drivers" != "x" ]; then
170 for d in $sound_drivers; do
171 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
172 fail "unsupported sound driver: $sound_driver"
173 fi
174 done
175fi
176
177if [ "$need_libpicofe" = "yes" ]; then
178 if ! test -f "frontend/libpicofe/README"; then
179 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
180 fi
181fi
182
183if [ "$need_warm" = "yes" ]; then
184 if ! test -f "frontend/warm/README"; then
185 fail "wARM is missing, please run 'git submodule init && git submodule update'"
186 fi
187fi
188
189# basic compiler test
190cat > $TMPC <<EOF
191#include <zlib.h>
192int main(void) { return 0; }
193EOF
194if ! compile_binary; then
195 fail "compiler test failed, please check config.log"
196fi
197
198if [ -z "$ARCH" ]; then
199 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
200fi
201
202case "$ARCH" in
203arm*)
204 # ARM stuff
205 ARCH="arm"
206
207 if [ "$optimize_cortexa8" = "yes" ]; then
208 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
209 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
210 fi
211 if [ "$optimize_arm926ej" = "yes" ]; then
212 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
213 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
214 fi
215
216 if [ "x$have_arm_neon" = "x" ]; then
217 # detect NEON from user-supplied cflags to enable neon code
218 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
219 fi
220 if [ "x$have_armv7" = "x" ]; then
221 if check_define HAVE_ARMV7; then
222 have_armv7="yes"
223 have_armv6="yes"
224 have_armv5="yes"
225 fi
226 fi
227 if [ "x$have_armv6" = "x" ]; then
228 if check_define HAVE_ARMV6; then
229 have_armv6="yes"
230 have_armv5="yes"
231 fi
232 fi
233 if [ "x$have_armv5" = "x" ]; then
234 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
235 fi
236
237 if [ "x$builtin_gpu" = "x" ]; then
238 if [ "$have_arm_neon" = "yes" ]; then
239 builtin_gpu="neon"
240 elif [ "$have_armv7" != "yes" ]; then
241 # pre-ARMv7 hardware is usually not fast enough for peops
242 builtin_gpu="unai"
243 else
244 builtin_gpu="peops"
245 fi
246 fi
247
248 # automatically set mfpu and mfloat-abi if they are not set
249 if [ "$have_arm_neon" = "yes" ]; then
250 fpu="neon"
251 elif [ "$have_armv6" = "yes" ]; then
252 fpu="vfp"
253 fi
254 if [ "x$fpu" != "x" ]; then
255 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
256 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
257 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
258 if [ "$floatabi_set_by_gcc" != "yes" ]; then
259 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
260 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
261 fi
262 fi
263
264 # must disable thumb as recompiler can't handle it
265 if check_define __thumb__; then
266 CFLAGS="$CFLAGS -marm"
267 fi
268
269 # warn about common mistakes
270 if [ "$have_armv5" != "yes" ]; then
271 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
272 echo "Warning: compiling for ARMv4, is that really what you want?"
273 echo "You probably should specify -mcpu= or -march= like this:"
274 echo " CFLAGS=-march=armv6 ./configure ..."
275 fi
276 fi
277 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
278 echo "Warning: compiling for NEON, but not ARMv7?"
279 echo "You probably want to specify -mcpu= or -march= like this:"
280 echo " CFLAGS=-march=armv7-a ./configure ..."
281 fi
282 have_arm_neon_asm=$have_arm_neon
283 ;;
284aarch64)
285 have_arm_neon="yes"
286 have_arm_neon_asm="no"
287 if [ "x$builtin_gpu" = "x" ]; then
288 builtin_gpu="neon"
289 fi
290 ;;
291x86_64)
292 enable_dynarec="no"
293 if [ "x$builtin_gpu" = "x" ]; then
294 builtin_gpu="neon"
295 fi
296 ;;
297*)
298 # dynarec only available on ARM
299 enable_dynarec="no"
300 ;;
301esac
302
303if [ "x$builtin_gpu" = "x" ]; then
304 builtin_gpu="peops"
305fi
306
307# supposedly we can avoid -fPIC on armv5 for slightly better performace?
308if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
309 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
310fi
311
312case "$platform" in
313generic)
314 need_sdl="yes"
315 ;;
316maemo)
317 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES"
318 ;;
319libretro)
320 CFLAGS="$CFLAGS -fPIC"
321 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
322 ;;
323esac
324
325# header/library presence tests
326check_zlib()
327{
328 cat > $TMPC <<EOF
329 #include <zlib.h>
330 int main(void) { uncompress(0, 0, 0, 0); }
331EOF
332 compile_binary
333}
334
335check_libpng()
336{
337 cat > $TMPC <<EOF
338 #include <png.h>
339 void main() { png_init_io(0, 0); }
340EOF
341 compile_binary
342}
343
344check_oss()
345{
346 cat > $TMPC <<EOF
347 #include <sys/soundcard.h>
348 #include <sys/ioctl.h>
349 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
350EOF
351 compile_binary
352}
353
354check_alsa()
355{
356 cat > $TMPC <<EOF
357 #include <alsa/asoundlib.h>
358 void main() { snd_pcm_open(0, 0, 0, 0); }
359EOF
360 compile_binary "$@"
361}
362
363check_pulseaudio()
364{
365 cat > $TMPC <<EOF
366 #include <pulse/pulseaudio.h>
367 void main() { pa_threaded_mainloop_new(); }
368EOF
369 compile_binary "$@"
370}
371
372check_sdl()
373{
374 cat > $TMPC <<EOF
375 #include <SDL.h>
376 void main() { SDL_OpenAudio(0, 0); }
377EOF
378 compile_binary "$@"
379}
380
381check_xlib_headers()
382{
383 cat > $TMPC <<EOF
384 #include <X11/Xlib.h>
385 void *f() { return XOpenDisplay(0); }
386EOF
387 compile_object "$@"
388}
389
390# see if we have c64_tools for TI C64x DSP
391check_c64_tools()
392{
393 cat > $TMPC <<EOF
394 #include <inc_libc64_mini.h>
395 int f() { return dsp_open(); }
396EOF
397 compile_object "$@"
398}
399
400MAIN_LDLIBS="$MAIN_LDLIBS -lz"
401check_zlib || fail "please install zlib (libz-dev)"
402
403MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
404check_libpng || fail "please install libpng (libpng-dev)"
405
406# find what audio support we can compile
407if [ "x$sound_drivers" = "x" ]; then
408 if check_oss; then sound_drivers="$sound_drivers oss"; fi
409 if check_alsa -lasound; then
410 sound_drivers="$sound_drivers alsa"
411 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
412 fi
413 if check_pulseaudio -lpulse; then
414 sound_drivers="$sound_drivers pulseaudio"
415 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
416 fi
417 if [ "$need_sdl" = "yes" ] || check_sdl `${SDL_CONFIG} --cflags --libs`; then
418 sound_drivers="$sound_drivers sdl"
419 need_sdl="yes"
420 fi
421else
422 if echo $sound_drivers | grep -q "\<oss\>"; then
423 check_oss || fail "oss support is missing"
424 fi
425 if echo $sound_drivers | grep -q "\<alsa\>"; then
426 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
427 check_alsa || fail "please install libasound2-dev"
428 fi
429 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
430 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
431 check_pulseaudio || fail "pulseaudio support is missing"
432 fi
433fi
434
435if [ "$need_sdl" = "yes" ]; then
436 which ${SDL_CONFIG} > /dev/null || \
437 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
438 CFLAGS="$CFLAGS `${SDL_CONFIG} --cflags`"
439 MAIN_LDLIBS="`${SDL_CONFIG} --libs` $MAIN_LDLIBS"
440 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
441fi
442
443# check for tslib (only headers needed)
444if [ "x$have_tslib" = "x" ]; then
445 cat > $TMPC <<EOF
446 #include <tslib.h>
447 void test(struct ts_sample sample) {}
448EOF
449 if compile_object; then
450 have_tslib="yes"
451 else
452 have_tslib="no"
453 fi
454fi
455
456# check for VideoCore stuff for Raspberry Pi
457if [ -d /opt/vc/include -a -d /opt/vc/lib -a "$VIDEOCORE" != "no" ]; then
458 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux"
459 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
460 if [ -f /opt/vc/lib/libbcm_host.so ]; then
461 LDLIBS_GLES="$LDLIBS_GLES -lbcm_host"
462 fi
463 need_xlib="yes"
464 VIDEOCORE="yes"
465fi
466
467# check for GLES headers
468cat > $TMPC <<EOF
469#include <GLES/gl.h>
470#include <EGL/egl.h>
471int main(void) {
472 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
473}
474EOF
475if [ "$VIDEOCORE" = "yes" ] && compile_binary $CFLAGS_GLES -lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES; then
476 have_gles="yes"
477 LDLIBS_GLES="-lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES"
478elif compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
479 have_gles="yes"
480 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
481elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
482 have_gles="yes"
483 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
484fi
485
486if check_c64_tools; then
487 have_c64x_dsp="yes"
488fi
489
490if [ "$have_gles" = "yes" ]; then
491 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
492fi
493if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
494 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
495fi
496
497# check for xlib (only headers needed)
498if [ "x$need_xlib" = "xyes" ]; then
499 check_xlib_headers || fail "please install libx11-dev"
500fi
501
502sizeof_long=`check_define_val __SIZEOF_LONG__`
503if [ "x$sizeof_long" = "x4" ]; then
504 CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64"
505fi
506
507cat > $TMPC <<EOF
508void test(void *f, void *d) { fread(d, 1, 1, f); }
509EOF
510if compile_object -Wno-unused-result; then
511 CFLAGS="$CFLAGS -Wno-unused-result"
512fi
513
514# short plugin list for display
515for p in $plugins; do
516 p1=`basename $p`
517 plugins_short="$p1 $plugins_short"
518done
519
520# set things that failed to autodetect to "no"
521test "x$have_armv6" != "x" || have_armv6="no"
522test "x$have_armv7" != "x" || have_armv7="no"
523test "x$have_arm_neon" != "x" || have_arm_neon="no"
524test "x$have_arm_neon_asm" != "x" || have_arm_neon_asm="no"
525test "x$have_gles" != "x" || have_gles="no"
526test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no"
527
528echo "architecture $ARCH"
529echo "platform $platform"
530echo "built-in GPU $builtin_gpu"
531echo "sound drivers $sound_drivers"
532echo "plugins $plugins_short"
533echo "C compiler $CC"
534echo "C compiler flags $CFLAGS"
535echo "libraries $MAIN_LDLIBS"
536echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
537echo "enable dynarec $enable_dynarec"
538if [ "$ARCH" = "arm" -o "$ARCH" = "aarch64" ]; then
539 echo "enable ARM NEON $have_arm_neon"
540fi
541if [ "$ARCH" = "arm" ]; then
542 echo "ARMv7 optimizations $have_armv7"
543 echo "TI C64x DSP support $have_c64x_dsp"
544fi
545echo "tslib support $have_tslib"
546if [ "$platform" = "generic" ]; then
547 echo "OpenGL ES output $have_gles"
548fi
549
550echo "# Automatically generated by configure" > $config_mak
551printf "# Configured with:" >> $config_mak
552printf " '%s'" "$0" "$@" >> $config_mak
553echo >> $config_mak
554
555echo "CC = $CC" >> $config_mak
556echo "CXX = $CXX" >> $config_mak
557echo "AS = $AS" >> $config_mak
558echo "CFLAGS += $CFLAGS" >> $config_mak
559echo "ASFLAGS += $ASFLAGS" >> $config_mak
560echo "LDFLAGS += $LDFLAGS" >> $config_mak
561echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
562echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
563echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
564echo >> $config_mak
565
566if [ "$platform" = "libretro" ]; then
567 echo "TARGET = libretro.so" >> $config_mak
568fi
569echo "ARCH = $ARCH" >> $config_mak
570echo "PLATFORM = $platform" >> $config_mak
571echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
572echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
573echo "PLUGINS = $plugins" >> $config_mak
574if [ "$have_arm_neon" = "yes" ]; then
575 echo "HAVE_NEON = 1" >> $config_mak
576fi
577if [ "$have_arm_neon_asm" = "yes" ]; then
578 echo "HAVE_NEON_ASM = 1" >> $config_mak
579fi
580if [ "$have_tslib" = "yes" ]; then
581 echo "HAVE_TSLIB = 1" >> $config_mak
582fi
583if [ "$have_gles" = "yes" ]; then
584 echo "HAVE_GLES = 1" >> $config_mak
585 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
586 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
587fi
588if [ "$enable_dynarec" = "yes" ]; then
589 echo "USE_DYNAREC = 1" >> $config_mak
590fi
591if [ "$drc_cache_base" = "yes" ]; then
592 echo "BASE_ADDR_DYNAMIC = 1" >> $config_mak
593fi
594if [ "$have_c64x_dsp" = "yes" ]; then
595 echo "HAVE_C64_TOOLS = 1" >> $config_mak
596fi
597
598# use pandora's skin (for now)
599test -e skin || ln -s frontend/pandora/skin skin
600
601# vim:shiftwidth=2:expandtab